OpenCV: NPPST Image Processing

| OpenCV 3.4.2 Open Source Computer Vision

Classes | Enumerations | Functions
NPPST Image Processing
Core functionality » OpenGL interoperability » CUDA-accelerated Computer Vision » Legacy support

## Classes
struct | NppStInterpolationState

## Enumerations
enum | NppStBorderType { nppStBorderNone = 0, nppStBorderClamp = 1, nppStBorderWrap = 2, nppStBorderMirror = 3 }
enum | NppStInterpMode { nppStSupersample, nppStBicubic }

## Functions
NCVStatus | nppiStDecimate_32f_C1R (Ncv32f *d_src, Ncv32u srcStep, Ncv32f *d_dst, Ncv32u dstStep, NcvSize32u srcRoi, Ncv32u scale, NcvBool readThruTexture)
NCVStatus | nppiStDecimate_32f_C1R_host (Ncv32f *h_src, Ncv32u srcStep, Ncv32f *h_dst, Ncv32u dstStep, NcvSize32u srcRoi, Ncv32u scale)
NCVStatus | nppiStDecimate_32s_C1R (Ncv32s *d_src, Ncv32u srcStep, Ncv32s *d_dst, Ncv32u dstStep, NcvSize32u srcRoi, Ncv32u scale, NcvBool readThruTexture)
NCVStatus | nppiStDecimate_32s_C1R_host (Ncv32s *h_src, Ncv32u srcStep, Ncv32s *h_dst, Ncv32u dstStep, NcvSize32u srcRoi, Ncv32u scale)
NCVStatus | nppiStDecimate_32u_C1R (Ncv32u *d_src, Ncv32u srcStep, Ncv32u *d_dst, Ncv32u dstStep, NcvSize32u srcRoi, Ncv32u scale, NcvBool readThruTexture)
NCVStatus | nppiStDecimate_32u_C1R_host (Ncv32u *h_src, Ncv32u srcStep, Ncv32u *h_dst, Ncv32u dstStep, NcvSize32u srcRoi, Ncv32u scale)
NCVStatus | nppiStDecimate_64f_C1R (Ncv64f *d_src, Ncv32u srcStep, Ncv64f *d_dst, Ncv32u dstStep, NcvSize32u srcRoi, Ncv32u scale, NcvBool readThruTexture)
NCVStatus | nppiStDecimate_64f_C1R_host (Ncv64f *h_src, Ncv32u srcStep, Ncv64f *h_dst, Ncv32u dstStep, NcvSize32u srcRoi, Ncv32u scale)
NCVStatus | nppiStDecimate_64s_C1R (Ncv64s *d_src, Ncv32u srcStep, Ncv64s *d_dst, Ncv32u dstStep, NcvSize32u srcRoi, Ncv32u scale, NcvBool readThruTexture)
NCVStatus | nppiStDecimate_64s_C1R_host (Ncv64s *h_src, Ncv32u srcStep, Ncv64s *h_dst, Ncv32u dstStep, NcvSize32u srcRoi, Ncv32u scale)
NCVStatus | nppiStDecimate_64u_C1R (Ncv64u *d_src, Ncv32u srcStep, Ncv64u *d_dst, Ncv32u dstStep, NcvSize32u srcRoi, Ncv32u scale, NcvBool readThruTexture)
NCVStatus | nppiStDecimate_64u_C1R_host (Ncv64u *h_src, Ncv32u srcStep, Ncv64u *h_dst, Ncv32u dstStep, NcvSize32u srcRoi, Ncv32u scale)
NCVStatus | nppiStFilterColumnBorder_32f_C1R (const Ncv32f *pSrc, NcvSize32u srcSize, Ncv32u nSrcStep, Ncv32f *pDst, NcvSize32u dstSize, Ncv32u nDstStep, NcvRect32u oROI, NppStBorderType borderType, const Ncv32f *pKernel, Ncv32s nKernelSize, Ncv32s nAnchor, Ncv32f multiplier)
NCVStatus | nppiStFilterRowBorder_32f_C1R (const Ncv32f *pSrc, NcvSize32u srcSize, Ncv32u nSrcStep, Ncv32f *pDst, NcvSize32u dstSize, Ncv32u nDstStep, NcvRect32u oROI, NppStBorderType borderType, const Ncv32f *pKernel, Ncv32s nKernelSize, Ncv32s nAnchor, Ncv32f multiplier)
NCVStatus | nppiStGetInterpolationBufferSize (NcvSize32u srcSize, Ncv32u nStep, Ncv32u *hpSize)
NCVStatus | nppiStIntegral_32f32f_C1R (Ncv32f *d_src, Ncv32u srcStep, Ncv32f *d_dst, Ncv32u dstStep, NcvSize32u roiSize, Ncv8u *pBuffer, Ncv32u bufSize, cudaDeviceProp &devProp)
NCVStatus | nppiStIntegral_32f32f_C1R_host (Ncv32f *h_src, Ncv32u srcStep, Ncv32f *h_dst, Ncv32u dstStep, NcvSize32u roiSize)
NCVStatus | nppiStIntegral_8u32u_C1R (Ncv8u *d_src, Ncv32u srcStep, Ncv32u *d_dst, Ncv32u dstStep, NcvSize32u roiSize, Ncv8u *pBuffer, Ncv32u bufSize, cudaDeviceProp &devProp)
NCVStatus | nppiStIntegral_8u32u_C1R_host (Ncv8u *h_src, Ncv32u srcStep, Ncv32u *h_dst, Ncv32u dstStep, NcvSize32u roiSize)
NCVStatus | nppiStIntegralGetSize_32f32f (NcvSize32u roiSize, Ncv32u *pBufsize, cudaDeviceProp &devProp)
NCVStatus | nppiStIntegralGetSize_8u32u (NcvSize32u roiSize, Ncv32u *pBufsize, cudaDeviceProp &devProp)
NCVStatus | nppiStInterpolateFrames (const NppStInterpolationState *pState)
NCVStatus | nppiStRectStdDev_32f_C1R (Ncv32u *d_sum, Ncv32u sumStep, Ncv64u *d_sqsum, Ncv32u sqsumStep, Ncv32f *d_norm, Ncv32u normStep, NcvSize32u roi, NcvRect32u rect, Ncv32f scaleArea, NcvBool readThruTexture)
NCVStatus | nppiStRectStdDev_32f_C1R_host (Ncv32u *h_sum, Ncv32u sumStep, Ncv64u *h_sqsum, Ncv32u sqsumStep, Ncv32f *h_norm, Ncv32u normStep, NcvSize32u roi, NcvRect32u rect, Ncv32f scaleArea)
NCVStatus | nppiStResize_32f_C1R (const Ncv32f *pSrc, NcvSize32u srcSize, Ncv32u nSrcStep, NcvRect32u srcROI, Ncv32f *pDst, NcvSize32u dstSize, Ncv32u nDstStep, NcvRect32u dstROI, Ncv32f xFactor, Ncv32f yFactor, NppStInterpMode interpolation)
NCVStatus | nppiStSqrIntegral_8u64u_C1R (Ncv8u *d_src, Ncv32u srcStep, Ncv64u *d_dst, Ncv32u dstStep, NcvSize32u roiSize, Ncv8u *pBuffer, Ncv32u bufSize, cudaDeviceProp &devProp)
NCVStatus | nppiStSqrIntegral_8u64u_C1R_host (Ncv8u *h_src, Ncv32u srcStep, Ncv64u *h_dst, Ncv32u dstStep, NcvSize32u roiSize)
NCVStatus | nppiStSqrIntegralGetSize_8u64u (NcvSize32u roiSize, Ncv32u *pBufsize, cudaDeviceProp &devProp)
NCVStatus | nppiStTranspose_128_C1R (void *d_src, Ncv32u srcStep, void *d_dst, Ncv32u dstStep, NcvSize32u srcRoi)
NCVStatus | nppiStTranspose_128_C1R_host (void *d_src, Ncv32u srcStep, void *d_dst, Ncv32u dstStep, NcvSize32u srcRoi)
NCVStatus | nppiStTranspose_32f_C1R (Ncv32f *d_src, Ncv32u srcStride, Ncv32f *d_dst, Ncv32u dstStride, NcvSize32u srcRoi)
NCVStatus | nppiStTranspose_32f_C1R_host (Ncv32f *h_src, Ncv32u srcStride, Ncv32f *h_dst, Ncv32u dstStride, NcvSize32u srcRoi)
NCVStatus | nppiStTranspose_32s_C1R (Ncv32s *d_src, Ncv32u srcStride, Ncv32s *d_dst, Ncv32u dstStride, NcvSize32u srcRoi)
NCVStatus | nppiStTranspose_32s_C1R_host (Ncv32s *h_src, Ncv32u srcStride, Ncv32s *h_dst, Ncv32u dstStride, NcvSize32u srcRoi)
NCVStatus | nppiStTranspose_32u_C1R (Ncv32u *d_src, Ncv32u srcStride, Ncv32u *d_dst, Ncv32u dstStride, NcvSize32u srcRoi)
NCVStatus | nppiStTranspose_32u_C1R_host (Ncv32u *h_src, Ncv32u srcStride, Ncv32u *h_dst, Ncv32u dstStride, NcvSize32u srcRoi)
NCVStatus | nppiStTranspose_64f_C1R (Ncv64f *d_src, Ncv32u srcStride, Ncv64f *d_dst, Ncv32u dstStride, NcvSize32u srcRoi)
NCVStatus | nppiStTranspose_64f_C1R_host (Ncv64f *h_src, Ncv32u srcStride, Ncv64f *h_dst, Ncv32u dstStride, NcvSize32u srcRoi)
NCVStatus | nppiStTranspose_64s_C1R (Ncv64s *d_src, Ncv32u srcStride, Ncv64s *d_dst, Ncv32u dstStride, NcvSize32u srcRoi)
NCVStatus | nppiStTranspose_64s_C1R_host (Ncv64s *h_src, Ncv32u srcStride, Ncv64s *h_dst, Ncv32u dstStride, NcvSize32u srcRoi)
NCVStatus | nppiStTranspose_64u_C1R (Ncv64u *d_src, Ncv32u srcStride, Ncv64u *d_dst, Ncv32u dstStride, NcvSize32u srcRoi)
NCVStatus | nppiStTranspose_64u_C1R_host (Ncv64u *h_src, Ncv32u srcStride, Ncv64u *h_dst, Ncv32u dstStride, NcvSize32u srcRoi)
NCVStatus | nppiStVectorWarp_PSF1x1_32f_C1 (const Ncv32f *pSrc, NcvSize32u srcSize, Ncv32u nSrcStep, const Ncv32f *pU, const Ncv32f *pV, Ncv32u nVFStep, Ncv32f timeScale, Ncv32f *pDst)
NCVStatus | nppiStVectorWarp_PSF2x2_32f_C1 (const Ncv32f *pSrc, NcvSize32u srcSize, Ncv32u nSrcStep, const Ncv32f *pU, const Ncv32f *pV, Ncv32u nVFStep, Ncv32f *pBuffer, Ncv32f timeScale, Ncv32f *pDst)
NCVStatus | nppiStVectorWarpGetBufferSize (NcvSize32u srcSize, Ncv32u nSrcStep, Ncv32u *hpSize)

## Detailed Description

## Enumeration Type Documentation

## ◆ NppStBorderType

enum NppStBorderType

Border type

Filtering operations assume that each pixel has a neighborhood of pixels. The following structure describes possible ways to define non-existent pixels.

Enumerator
nppStBorderNone | There is no need to define additional pixels, image is extended already.
nppStBorderClamp | Clamp out of range position to borders.
nppStBorderWrap | Wrap out of range position. Image becomes periodic.
nppStBorderMirror | reflect out of range position across borders

## ◆ NppStInterpMode

enum NppStInterpMode

Filter types for image resizing

Enumerator
nppStSupersample | Supersampling. For downscaling only.
nppStBicubic | Bicubic convolution filter, a = -0.5 (cubic Hermite spline)

## Function Documentation

## ◆ nppiStDecimate_32f_C1R()

NCVStatus nppiStDecimate_32f_C1R | ( | Ncv32f * | d_src,
|  | Ncv32u | srcStep,
|  | Ncv32f * | d_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | srcRoi,
|  | Ncv32u | scale,
|  | NcvBool | readThruTexture
| ) |  |

Downsamples (decimates) an image using the nearest neighbor algorithm. 32-bit float pixels, single channel.

See also
  nppiStDecimate_32u_C1R

## ◆ nppiStDecimate_32f_C1R_host()

NCVStatus nppiStDecimate_32f_C1R_host | ( | Ncv32f * | h_src,
|  | Ncv32u | srcStep,
|  | Ncv32f * | h_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | srcRoi,
|  | Ncv32u | scale
| ) |  |

Downsamples (decimates) an image using the nearest neighbor algorithm. 32-bit float pixels, single channel. Host implementation.

See also
  nppiStDecimate_32u_C1R_host

## ◆ nppiStDecimate_32s_C1R()

NCVStatus nppiStDecimate_32s_C1R | ( | Ncv32s * | d_src,
|  | Ncv32u | srcStep,
|  | Ncv32s * | d_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | srcRoi,
|  | Ncv32u | scale,
|  | NcvBool | readThruTexture
| ) |  |

Downsamples (decimates) an image using the nearest neighbor algorithm. 32-bit signed pixels, single channel.

See also
  nppiStDecimate_32u_C1R

## ◆ nppiStDecimate_32s_C1R_host()

NCVStatus nppiStDecimate_32s_C1R_host | ( | Ncv32s * | h_src,
|  | Ncv32u | srcStep,
|  | Ncv32s * | h_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | srcRoi,
|  | Ncv32u | scale
| ) |  |

Downsamples (decimates) an image using the nearest neighbor algorithm. 32-bit signed pixels, single channel. Host implementation.

See also
  nppiStDecimate_32u_C1R_host

## ◆ nppiStDecimate_32u_C1R()

NCVStatus nppiStDecimate_32u_C1R | ( | Ncv32u * | d_src,
|  | Ncv32u | srcStep,
|  | Ncv32u * | d_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | srcRoi,
|  | Ncv32u | scale,
|  | NcvBool | readThruTexture
| ) |  |

Downsamples (decimates) an image using the nearest neighbor algorithm. 32-bit unsigned pixels, single channel.

Parameters

  d_src | [IN] Source image pointer (CUDA device memory)
  srcStep | [IN] Source image line step
  d_dst | [OUT] Destination image pointer (CUDA device memory)
  dstStep | [IN] Destination image line step
  srcRoi | [IN] Region of interest in the source image
  scale | [IN] Downsampling scale factor (positive integer)
  readThruTexture | [IN] Performance hint to cache source in texture (true) or read directly (false)

Returns
  NCV status code

## ◆ nppiStDecimate_32u_C1R_host()

NCVStatus nppiStDecimate_32u_C1R_host | ( | Ncv32u * | h_src,
|  | Ncv32u | srcStep,
|  | Ncv32u * | h_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | srcRoi,
|  | Ncv32u | scale
| ) |  |

Downsamples (decimates) an image using the nearest neighbor algorithm. 32-bit unsigned pixels, single channel. Host implementation.

Parameters

  h_src | [IN] Source image pointer (Host or pinned memory)
  srcStep | [IN] Source image line step
  h_dst | [OUT] Destination image pointer (Host or pinned memory)
  dstStep | [IN] Destination image line step
  srcRoi | [IN] Region of interest in the source image
  scale | [IN] Downsampling scale factor (positive integer)

Returns
  NCV status code

## ◆ nppiStDecimate_64f_C1R()

NCVStatus nppiStDecimate_64f_C1R | ( | Ncv64f * | d_src,
|  | Ncv32u | srcStep,
|  | Ncv64f * | d_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | srcRoi,
|  | Ncv32u | scale,
|  | NcvBool | readThruTexture
| ) |  |

Downsamples (decimates) an image using the nearest neighbor algorithm. 64-bit float pixels, single channel.

See also
  nppiStDecimate_32u_C1R

## ◆ nppiStDecimate_64f_C1R_host()

NCVStatus nppiStDecimate_64f_C1R_host | ( | Ncv64f * | h_src,
|  | Ncv32u | srcStep,
|  | Ncv64f * | h_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | srcRoi,
|  | Ncv32u | scale
| ) |  |

Downsamples (decimates) an image using the nearest neighbor algorithm. 64-bit float pixels, single channel. Host implementation.

See also
  nppiStDecimate_32u_C1R_host

## ◆ nppiStDecimate_64s_C1R()

NCVStatus nppiStDecimate_64s_C1R | ( | Ncv64s * | d_src,
|  | Ncv32u | srcStep,
|  | Ncv64s * | d_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | srcRoi,
|  | Ncv32u | scale,
|  | NcvBool | readThruTexture
| ) |  |

Downsamples (decimates) an image using the nearest neighbor algorithm. 64-bit signed pixels, single channel.

See also
  nppiStDecimate_32u_C1R

## ◆ nppiStDecimate_64s_C1R_host()

NCVStatus nppiStDecimate_64s_C1R_host | ( | Ncv64s * | h_src,
|  | Ncv32u | srcStep,
|  | Ncv64s * | h_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | srcRoi,
|  | Ncv32u | scale
| ) |  |

Downsamples (decimates) an image using the nearest neighbor algorithm. 64-bit signed pixels, single channel. Host implementation.

See also
  nppiStDecimate_32u_C1R_host

## ◆ nppiStDecimate_64u_C1R()

NCVStatus nppiStDecimate_64u_C1R | ( | Ncv64u * | d_src,
|  | Ncv32u | srcStep,
|  | Ncv64u * | d_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | srcRoi,
|  | Ncv32u | scale,
|  | NcvBool | readThruTexture
| ) |  |

Downsamples (decimates) an image using the nearest neighbor algorithm. 64-bit unsigned pixels, single channel.

See also
  nppiStDecimate_32u_C1R

## ◆ nppiStDecimate_64u_C1R_host()

NCVStatus nppiStDecimate_64u_C1R_host | ( | Ncv64u * | h_src,
|  | Ncv32u | srcStep,
|  | Ncv64u * | h_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | srcRoi,
|  | Ncv32u | scale
| ) |  |

Downsamples (decimates) an image using the nearest neighbor algorithm. 64-bit unsigned pixels, single channel. Host implementation.

See also
  nppiStDecimate_32u_C1R_host

## ◆ nppiStFilterColumnBorder_32f_C1R()

NCVStatus nppiStFilterColumnBorder_32f_C1R | ( | const Ncv32f * | pSrc,
|  | NcvSize32u | srcSize,
|  | Ncv32u | nSrcStep,
|  | Ncv32f * | pDst,
|  | NcvSize32u | dstSize,
|  | Ncv32u | nDstStep,
|  | NcvRect32u | oROI,
|  | NppStBorderType | borderType,
|  | const Ncv32f * | pKernel,
|  | Ncv32s | nKernelSize,
|  | Ncv32s | nAnchor,
|  | Ncv32f | multiplier
| ) |  |

Column linear filter. 32-bit floating point image, single channel

Apply vertical linear filter

Parameters

  pSrc | [IN] Source image pointer (CUDA device memory)
  srcSize | [IN] Source image size
  nSrcStep | [IN] Source image line step
  pDst | [OUT] Destination image pointer (CUDA device memory)
  dstSize | [OUT] Destination image size
  nDstStep | [IN]
  oROI | [IN] Region of interest in the source image
  borderType | [IN] Type of border
  pKernel | [IN] Pointer to column kernel values (CUDA device memory)
  nKernelSize | [IN] Size of the kernel in pixels
  nAnchor | [IN] The kernel column alignment with respect to the position of the input pixel
  multiplier | [IN] Value by which the computed result is multiplied

Returns
  NCV status code

## ◆ nppiStFilterRowBorder_32f_C1R()

NCVStatus nppiStFilterRowBorder_32f_C1R | ( | const Ncv32f * | pSrc,
|  | NcvSize32u | srcSize,
|  | Ncv32u | nSrcStep,
|  | Ncv32f * | pDst,
|  | NcvSize32u | dstSize,
|  | Ncv32u | nDstStep,
|  | NcvRect32u | oROI,
|  | NppStBorderType | borderType,
|  | const Ncv32f * | pKernel,
|  | Ncv32s | nKernelSize,
|  | Ncv32s | nAnchor,
|  | Ncv32f | multiplier
| ) |  |

Row linear filter. 32-bit floating point image, single channel

Apply horizontal linear filter

Parameters

  pSrc | [IN] Source image pointer (CUDA device memory)
  srcSize | [IN] Source image size
  nSrcStep | [IN] Source image line step
  pDst | [OUT] Destination image pointer (CUDA device memory)
  dstSize | [OUT] Destination image size
  nDstStep |
  oROI | [IN] Region of interest in the source image
  borderType | [IN] Type of border
  pKernel | [IN] Pointer to row kernel values (CUDA device memory)
  nKernelSize | [IN] Size of the kernel in pixels
  nAnchor | [IN] The kernel row alignment with respect to the position of the input pixel
  multiplier | [IN] Value by which the computed result is multiplied

Returns
  NCV status code

## ◆ nppiStGetInterpolationBufferSize()

NCVStatus nppiStGetInterpolationBufferSize | ( | NcvSize32u | srcSize,
|  | Ncv32u | nStep,
|  | Ncv32u * | hpSize
| ) |  |

Size of a buffer required for interpolation.

Requires several such buffers. See

See also
  NppStInterpolationState.

Parameters

  srcSize | [IN] Frame size (both frames must be of the same size)
  nStep | [IN] Frame line step
  hpSize | [OUT] Where to store computed size (host memory)

Returns
  NCV status code

## ◆ nppiStIntegral_32f32f_C1R()

NCVStatus nppiStIntegral_32f32f_C1R | ( | Ncv32f * | d_src,
|  | Ncv32u | srcStep,
|  | Ncv32f * | d_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | roiSize,
|  | Ncv8u * | pBuffer,
|  | Ncv32u | bufSize,
|  | cudaDeviceProp & | devProp
| ) |  |

Creates an integral image representation for the input image

See also
  nppiStIntegral_8u32u_C1R

## ◆ nppiStIntegral_32f32f_C1R_host()

NCVStatus nppiStIntegral_32f32f_C1R_host | ( | Ncv32f * | h_src,
|  | Ncv32u | srcStep,
|  | Ncv32f * | h_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | roiSize
| ) |  |

Creates an integral image representation for the input image. Host implementation

See also
  nppiStIntegral_8u32u_C1R_host

## ◆ nppiStIntegral_8u32u_C1R()

NCVStatus nppiStIntegral_8u32u_C1R | ( | Ncv8u * | d_src,
|  | Ncv32u | srcStep,
|  | Ncv32u * | d_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | roiSize,
|  | Ncv8u * | pBuffer,
|  | Ncv32u | bufSize,
|  | cudaDeviceProp & | devProp
| ) |  |

Creates an integral image representation for the input image

Parameters

  d_src | [IN] Source image pointer (CUDA device memory)
  srcStep | [IN] Source image line step
  d_dst | [OUT] Destination integral image pointer (CUDA device memory)
  dstStep | [IN] Destination image line step
  roiSize | [IN] Region of interest of the source image
  pBuffer | [IN] Pointer to the pre-allocated temporary buffer (CUDA device memory)
  bufSize | [IN] Size of the pBuffer in bytes
  devProp | [IN] CUDA device properties structure, containing texture alignment information

Returns
  NCV status code

## ◆ nppiStIntegral_8u32u_C1R_host()

NCVStatus nppiStIntegral_8u32u_C1R_host | ( | Ncv8u * | h_src,
|  | Ncv32u | srcStep,
|  | Ncv32u * | h_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | roiSize
| ) |  |

Creates an integral image representation for the input image. Host implementation

Parameters

  h_src | [IN] Source image pointer (Host or pinned memory)
  srcStep | [IN] Source image line step
  h_dst | [OUT] Destination integral image pointer (Host or pinned memory)
  dstStep | [IN] Destination image line step
  roiSize | [IN] Region of interest of the source image

Returns
  NCV status code

## ◆ nppiStIntegralGetSize_32f32f()

NCVStatus nppiStIntegralGetSize_32f32f | ( | NcvSize32u | roiSize,
|  | Ncv32u * | pBufsize,
|  | cudaDeviceProp & | devProp
| ) |  |

Calculates the size of the temporary buffer for integral image creation

See also
  nppiStIntegralGetSize_8u32u

## ◆ nppiStIntegralGetSize_8u32u()

NCVStatus nppiStIntegralGetSize_8u32u | ( | NcvSize32u | roiSize,
|  | Ncv32u * | pBufsize,
|  | cudaDeviceProp & | devProp
| ) |  |

Calculates the size of the temporary buffer for integral image creation

Parameters

  roiSize | [IN] Size of the input image
  pBufsize | [OUT] Pointer to host variable that returns the size of the temporary buffer (in bytes)
  devProp | [IN] CUDA device properties structure, containing texture alignment information

Returns
  NCV status code

## ◆ nppiStInterpolateFrames()

NCVStatus nppiStInterpolateFrames | ( | const NppStInterpolationState * | pState | ) |

Interpolate frames (images) using provided optical flow (displacement field). 32-bit floating point images, single channel

Parameters

  pState | [IN] structure containing all required parameters (host memory)

Returns
  NCV status code

## ◆ nppiStRectStdDev_32f_C1R()

NCVStatus nppiStRectStdDev_32f_C1R | ( | Ncv32u * | d_sum,
|  | Ncv32u | sumStep,
|  | Ncv64u * | d_sqsum,
|  | Ncv32u | sqsumStep,
|  | Ncv32f * | d_norm,
|  | Ncv32u | normStep,
|  | NcvSize32u | roi,
|  | NcvRect32u | rect,
|  | Ncv32f | scaleArea,
|  | NcvBool | readThruTexture
| ) |  |

Computes standard deviation for each rectangular region of the input image using integral images.

Parameters

  d_sum | [IN] Integral image pointer (CUDA device memory)
  sumStep | [IN] Integral image line step
  d_sqsum | [IN] Squared integral image pointer (CUDA device memory)
  sqsumStep | [IN] Squared integral image line step
  d_norm | [OUT] Stddev image pointer (CUDA device memory). Each pixel contains stddev of a rect with top-left corner at the original location in the image
  normStep | [IN] Stddev image line step
  roi | [IN] Region of interest in the source image
  rect | [IN] Rectangular region to calculate stddev over
  scaleArea | [IN] Multiplication factor to account decimated scale
  readThruTexture | [IN] Performance hint to cache source in texture (true) or read directly (false)

Returns
  NCV status code

## ◆ nppiStRectStdDev_32f_C1R_host()

NCVStatus nppiStRectStdDev_32f_C1R_host | ( | Ncv32u * | h_sum,
|  | Ncv32u | sumStep,
|  | Ncv64u * | h_sqsum,
|  | Ncv32u | sqsumStep,
|  | Ncv32f * | h_norm,
|  | Ncv32u | normStep,
|  | NcvSize32u | roi,
|  | NcvRect32u | rect,
|  | Ncv32f | scaleArea
| ) |  |

Computes standard deviation for each rectangular region of the input image using integral images. Host implementation

Parameters

  h_sum | [IN] Integral image pointer (Host or pinned memory)
  sumStep | [IN] Integral image line step
  h_sqsum | [IN] Squared integral image pointer (Host or pinned memory)
  sqsumStep | [IN] Squared integral image line step
  h_norm | [OUT] Stddev image pointer (Host or pinned memory). Each pixel contains stddev of a rect with top-left corner at the original location in the image
  normStep | [IN] Stddev image line step
  roi | [IN] Region of interest in the source image
  rect | [IN] Rectangular region to calculate stddev over
  scaleArea | [IN] Multiplication factor to account decimated scale

Returns
  NCV status code

## ◆ nppiStResize_32f_C1R()

NCVStatus nppiStResize_32f_C1R | ( | const Ncv32f * | pSrc,
|  | NcvSize32u | srcSize,
|  | Ncv32u | nSrcStep,
|  | NcvRect32u | srcROI,
|  | Ncv32f * | pDst,
|  | NcvSize32u | dstSize,
|  | Ncv32u | nDstStep,
|  | NcvRect32u | dstROI,
|  | Ncv32f | xFactor,
|  | Ncv32f | yFactor,
|  | NppStInterpMode | interpolation
| ) |  |

Resize. 32-bit floating point image, single channel

Resizes image using specified filter (interpolation type)

Parameters

  pSrc | [IN] Source image pointer (CUDA device memory)
  srcSize | [IN] Source image size
  nSrcStep | [IN] Source image line step
  srcROI | [IN] Source image region of interest
  pDst | [OUT] Destination image pointer (CUDA device memory)
  dstSize | [IN] Destination image size
  nDstStep | [IN] Destination image line step
  dstROI | [IN] Destination image region of interest
  xFactor | [IN] Row scale factor
  yFactor | [IN] Column scale factor
  interpolation | [IN] Interpolation type

Returns
  NCV status code

## ◆ nppiStSqrIntegral_8u64u_C1R()

NCVStatus nppiStSqrIntegral_8u64u_C1R | ( | Ncv8u * | d_src,
|  | Ncv32u | srcStep,
|  | Ncv64u * | d_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | roiSize,
|  | Ncv8u * | pBuffer,
|  | Ncv32u | bufSize,
|  | cudaDeviceProp & | devProp
| ) |  |

Creates a squared integral image representation for the input image

Parameters

  d_src | [IN] Source image pointer (CUDA device memory)
  srcStep | [IN] Source image line step
  d_dst | [OUT] Destination squared integral image pointer (CUDA device memory)
  dstStep | [IN] Destination image line step
  roiSize | [IN] Region of interest of the source image
  pBuffer | [IN] Pointer to the pre-allocated temporary buffer (CUDA device memory)
  bufSize | [IN] Size of the pBuffer in bytes
  devProp | [IN] CUDA device properties structure, containing texture alignment information

Returns
  NCV status code

## ◆ nppiStSqrIntegral_8u64u_C1R_host()

NCVStatus nppiStSqrIntegral_8u64u_C1R_host | ( | Ncv8u * | h_src,
|  | Ncv32u | srcStep,
|  | Ncv64u * | h_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | roiSize
| ) |  |

Creates a squared integral image representation for the input image. Host implementation

Parameters

  h_src | [IN] Source image pointer (Host or pinned memory)
  srcStep | [IN] Source image line step
  h_dst | [OUT] Destination squared integral image pointer (Host or pinned memory)
  dstStep | [IN] Destination image line step
  roiSize | [IN] Region of interest of the source image

Returns
  NCV status code

## ◆ nppiStSqrIntegralGetSize_8u64u()

NCVStatus nppiStSqrIntegralGetSize_8u64u | ( | NcvSize32u | roiSize,
|  | Ncv32u * | pBufsize,
|  | cudaDeviceProp & | devProp
| ) |  |

Calculates the size of the temporary buffer for squared integral image creation

Parameters

  roiSize | [IN] Size of the input image
  pBufsize | [OUT] Pointer to host variable that returns the size of the temporary buffer (in bytes)
  devProp | [IN] CUDA device properties structure, containing texture alignment information

Returns
  NCV status code

## ◆ nppiStTranspose_128_C1R()

NCVStatus nppiStTranspose_128_C1R | ( | void * | d_src,
|  | Ncv32u | srcStep,
|  | void * | d_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | srcRoi
| ) |  |

Transposes an image. 128-bit pixels of any type, single channel

See also
  nppiStTranspose_32u_C1R

## ◆ nppiStTranspose_128_C1R_host()

NCVStatus nppiStTranspose_128_C1R_host | ( | void * | d_src,
|  | Ncv32u | srcStep,
|  | void * | d_dst,
|  | Ncv32u | dstStep,
|  | NcvSize32u | srcRoi
| ) |  |

Transposes an image. 128-bit pixels of any type, single channel. Host implementation

See also
  nppiStTranspose_32u_C1R_host

## ◆ nppiStTranspose_32f_C1R()

NCVStatus nppiStTranspose_32f_C1R | ( | Ncv32f * | d_src,
|  | Ncv32u | srcStride,
|  | Ncv32f * | d_dst,
|  | Ncv32u | dstStride,
|  | NcvSize32u | srcRoi
| ) |  |

Transposes an image. 32-bit float pixels, single channel

See also
  nppiStTranspose_32u_C1R

## ◆ nppiStTranspose_32f_C1R_host()

NCVStatus nppiStTranspose_32f_C1R_host | ( | Ncv32f * | h_src,
|  | Ncv32u | srcStride,
|  | Ncv32f * | h_dst,
|  | Ncv32u | dstStride,
|  | NcvSize32u | srcRoi
| ) |  |

Transposes an image. 32-bit float pixels, single channel. Host implementation

See also
  nppiStTranspose_32u_C1R_host

## ◆ nppiStTranspose_32s_C1R()

NCVStatus nppiStTranspose_32s_C1R | ( | Ncv32s * | d_src,
|  | Ncv32u | srcStride,
|  | Ncv32s * | d_dst,
|  | Ncv32u | dstStride,
|  | NcvSize32u | srcRoi
| ) |  |

Transposes an image. 32-bit signed pixels, single channel

See also
  nppiStTranspose_32u_C1R

## ◆ nppiStTranspose_32s_C1R_host()

NCVStatus nppiStTranspose_32s_C1R_host | ( | Ncv32s * | h_src,
|  | Ncv32u | srcStride,
|  | Ncv32s * | h_dst,
|  | Ncv32u | dstStride,
|  | NcvSize32u | srcRoi
| ) |  |

Transposes an image. 32-bit signed pixels, single channel. Host implementation

See also
  nppiStTranspose_32u_C1R_host

## ◆ nppiStTranspose_32u_C1R()

NCVStatus nppiStTranspose_32u_C1R | ( | Ncv32u * | d_src,
|  | Ncv32u | srcStride,
|  | Ncv32u * | d_dst,
|  | Ncv32u | dstStride,
|  | NcvSize32u | srcRoi
| ) |  |

Transposes an image. 32-bit unsigned pixels, single channel

Parameters

  d_src | [IN] Source image pointer (CUDA device memory)
  srcStride | [IN] Source image line step
  d_dst | [OUT] Destination image pointer (CUDA device memory)
  dstStride | [IN] Destination image line step
  srcRoi | [IN] Region of interest of the source image

Returns
  NCV status code

## ◆ nppiStTranspose_32u_C1R_host()

NCVStatus nppiStTranspose_32u_C1R_host | ( | Ncv32u * | h_src,
|  | Ncv32u | srcStride,
|  | Ncv32u * | h_dst,
|  | Ncv32u | dstStride,
|  | NcvSize32u | srcRoi
| ) |  |

Transposes an image. 32-bit unsigned pixels, single channel. Host implementation

Parameters

  h_src | [IN] Source image pointer (Host or pinned memory)
  srcStride | [IN] Source image line step
  h_dst | [OUT] Destination image pointer (Host or pinned memory)
  dstStride | [IN] Destination image line step
  srcRoi | [IN] Region of interest of the source image

Returns
  NCV status code

## ◆ nppiStTranspose_64f_C1R()

NCVStatus nppiStTranspose_64f_C1R | ( | Ncv64f * | d_src,
|  | Ncv32u | srcStride,
|  | Ncv64f * | d_dst,
|  | Ncv32u | dstStride,
|  | NcvSize32u | srcRoi
| ) |  |

Transposes an image. 64-bit float pixels, single channel

See also
  nppiStTranspose_32u_C1R

## ◆ nppiStTranspose_64f_C1R_host()

NCVStatus nppiStTranspose_64f_C1R_host | ( | Ncv64f * | h_src,
|  | Ncv32u | srcStride,
|  | Ncv64f * | h_dst,
|  | Ncv32u | dstStride,
|  | NcvSize32u | srcRoi
| ) |  |

Transposes an image. 64-bit float pixels, single channel. Host implementation

See also
  nppiStTranspose_32u_C1R_host

## ◆ nppiStTranspose_64s_C1R()

NCVStatus nppiStTranspose_64s_C1R | ( | Ncv64s * | d_src,
|  | Ncv32u | srcStride,
|  | Ncv64s * | d_dst,
|  | Ncv32u | dstStride,
|  | NcvSize32u | srcRoi
| ) |  |

Transposes an image. 64-bit signed pixels, single channel

See also
  nppiStTranspose_32u_C1R

## ◆ nppiStTranspose_64s_C1R_host()

NCVStatus nppiStTranspose_64s_C1R_host | ( | Ncv64s * | h_src,
|  | Ncv32u | srcStride,
|  | Ncv64s * | h_dst,
|  | Ncv32u | dstStride,
|  | NcvSize32u | srcRoi
| ) |  |

Transposes an image. 64-bit signed pixels, single channel. Host implementation

See also
  nppiStTranspose_32u_C1R_host

## ◆ nppiStTranspose_64u_C1R()

NCVStatus nppiStTranspose_64u_C1R | ( | Ncv64u * | d_src,
|  | Ncv32u | srcStride,
|  | Ncv64u * | d_dst,
|  | Ncv32u | dstStride,
|  | NcvSize32u | srcRoi
| ) |  |

Transposes an image. 64-bit unsigned pixels, single channel

See also
  nppiStTranspose_32u_C1R

## ◆ nppiStTranspose_64u_C1R_host()

NCVStatus nppiStTranspose_64u_C1R_host | ( | Ncv64u * | h_src,
|  | Ncv32u | srcStride,
|  | Ncv64u * | h_dst,
|  | Ncv32u | dstStride,
|  | NcvSize32u | srcRoi
| ) |  |

Transposes an image. 64-bit unsigned pixels, single channel. Host implementation

See also
  nppiStTranspose_32u_C1R_host

## ◆ nppiStVectorWarp_PSF1x1_32f_C1()

NCVStatus nppiStVectorWarp_PSF1x1_32f_C1 | ( | const Ncv32f * | pSrc,
|  | NcvSize32u | srcSize,
|  | Ncv32u | nSrcStep,
|  | const Ncv32f * | pU,
|  | const Ncv32f * | pV,
|  | Ncv32u | nVFStep,
|  | Ncv32f | timeScale,
|  | Ncv32f * | pDst
| ) |  |

Warp image using provided 2D vector field and 1x1 point spread function. 32-bit floating point image, single channel

During warping pixels from the source image may fall between pixels of the destination image. PSF (point spread function) describes how the source image pixel affects pixels of the destination. For 1x1 PSF only single pixel with the largest intersection is affected (similar to nearest interpolation).

Destination image size and line step must be the same as the source image size and line step

Parameters

  pSrc | [IN] Source image pointer (CUDA device memory)
  srcSize | [IN] Source image size
  nSrcStep | [IN] Source image line step
  pU | [IN] Pointer to horizontal displacement field (CUDA device memory)
  pV | [IN] Pointer to vertical displacement field (CUDA device memory)
  nVFStep | [IN] Displacement field line step
  timeScale | [IN] Value by which displacement field will be scaled for warping
  pDst | [OUT] Destination image pointer (CUDA device memory)

Returns
  NCV status code

## ◆ nppiStVectorWarp_PSF2x2_32f_C1()

NCVStatus nppiStVectorWarp_PSF2x2_32f_C1 | ( | const Ncv32f * | pSrc,
|  | NcvSize32u | srcSize,
|  | Ncv32u | nSrcStep,
|  | const Ncv32f * | pU,
|  | const Ncv32f * | pV,
|  | Ncv32u | nVFStep,
|  | Ncv32f * | pBuffer,
|  | Ncv32f | timeScale,
|  | Ncv32f * | pDst
| ) |  |

Warp image using provided 2D vector field and 2x2 point spread function. 32-bit floating point image, single channel

During warping pixels from the source image may fall between pixels of the destination image. PSF (point spread function) describes how the source image pixel affects pixels of the destination. For 2x2 PSF all four intersected pixels will be affected.

Destination image size and line step must be the same as the source image size and line step

Parameters

  pSrc | [IN] Source image pointer (CUDA device memory)
  srcSize | [IN] Source image size
  nSrcStep | [IN] Source image line step
  pU | [IN] Pointer to horizontal displacement field (CUDA device memory)
  pV | [IN] Pointer to vertical displacement field (CUDA device memory)
  nVFStep | [IN] Displacement field line step
  pBuffer |
  timeScale | [IN] Value by which displacement field will be scaled for warping
  pDst | [OUT] Destination image pointer (CUDA device memory)

Returns
  NCV status code

## ◆ nppiStVectorWarpGetBufferSize()

NCVStatus nppiStVectorWarpGetBufferSize | ( | NcvSize32u | srcSize,
|  | Ncv32u | nSrcStep,
|  | Ncv32u * | hpSize
| ) |  |

Size of buffer required for vector image warping.

Parameters

  srcSize | [IN] Source image size
  nSrcStep | [IN] Source image line step
  hpSize | [OUT] Where to store computed size (host memory)

Returns
  NCV status code